#include "stdafx.h"
#include <ablib/textfile.h>
#include <system/FindFile.h>
#include <system/Process.h>
#include <ablib/IsKanji.h>
//#include <hmjre_dll/RegEx.h>
#include <regex>
#include <ablib/Pathname.h>
#include <algorithm>
#include "func.h"
#include "file.h"
#include "texproject.h"
//#include "collectstr.h"

namespace{
	inline void split(std::vector<ablib::string> &rvalue,ablib::string &value,const TCHAR *key){
		int r = 0;
		const TCHAR *q = value.c_str();
		TCHAR tmp;
		int len = ::lstrlen(key);
		while((r = value.find(key,r)) != ablib::string::npos){
			tmp = value[r];
			value[r] = '\0';
			rvalue.push_back(q);
			value[r] = tmp;
			r += len;
			q = value.c_str() + r;
		}
		return;
	}

	template<typename T> void SlashToYen_impl(T str,int len){
#ifdef UNICODE
		for(UINT i = 0 ; i < len ; ++i){
#else
		for(int i = 0 ; i < len ; i += (ablib::IsKanji(str[i]) ? 2 : 1)){
#endif
			if(str[i] == '/')str[i] = '\\';
		}
		return;
	}
	inline void SlashToYen(ablib::string &str){return SlashToYen_impl<ablib::string&>(str,str.length());}
	inline void SlashToYen(TCHAR *str){return SlashToYen_impl(str,::lstrlen(str));}
}

int TeXProject::CreateFileList(const TCHAR *file){
	m_files.clear();
	m_files.push_back(FileData(FileData::main,_T("")));
	CreateList(file);
	m_files[0] = FileData(FileData::main,file);
	return TRUE;
}

const TCHAR *TeXProject::GetFile(){
	if(m_num >= m_files.size())return _T("");
	return m_files[m_num++].name.c_str();
}

void TeXProject::CreateList(const TCHAR *file){
	for(UINT j = 0 ; j < m_files.size() ; ++j){
		if(File::CheckSameFile(file,m_files[j].name.c_str()))return;
	}
	ablib::string dir = ablib::Pathname(file).dirname();
	ablib::TextFile tf;
	if(!tf.Open(file,ablib::TextFile::read))return;
	TCHAR buf[4096];
	ablib::string tmp;
	while(tf.ReadLine(buf,4096)){
		tmp = GetInput(buf,dir,_T("\\input"));
		if(tmp != _T("")){
			m_files.push_back(FileData(FileData::input,tmp));
			CreateList(tmp.c_str());
		}
		tmp = GetInput(buf,dir,_T("\\include"));
		if(tmp != _T("")){
			m_files.push_back(FileData(FileData::include,tmp));
			CreateList(tmp.c_str());
		}
	}
	m_num = 0;
	return;
}

ablib::string TeXProject::GetInput(const TCHAR *str,const ablib::string &dir,const TCHAR *keys){
	int len;
	auto p = ::_tcsstr(str, keys);
	if (p == nullptr)return _T("");
	auto per = ::_tcsstr(str,_T("%"));
	auto ver = ::_tcsstr(str, _T("\\verb"));
	auto musitop = str + 99999;
	if (per != nullptr)musitop = std::min(musitop, per);
	if (ver != nullptr)musitop = std::min(musitop, ver);
	bool musi = (ver != nullptr || per != nullptr);
	if(musi && musitop < p)return _T("");
	len = ::lstrlen(keys);
	if(*(p + len) != '{' && *(p + len) != '[')return _T("");
	p = ::_tcsstr(p,_T("{"));
	if(p == NULL)return _T("");
	++p;
	const TCHAR *q = ::_tcsstr(p,_T("}"));
	if(q == NULL)return _T("");
	ablib::string rv;
	rv = dir;
	rv.append(p, q - p);
	SlashToYen(rv);
	if(!(rv.length() >= 4 &&
		(rv[rv.length() - 1] == 'x' || rv[rv.length() - 1] == 'X') &&
		(rv[rv.length() - 2] == 'e' || rv[rv.length() - 2] == 'E') &&
		(rv[rv.length() - 3] == 't' || rv[rv.length() - 3] == 'T') &&
		(rv[rv.length() - 4] == '.')))rv += _T(".tex");
	
	return rv;
}

bool TeXProject::SearchDocumentClass(const ablib::string &file, ablib::string &option, ablib::string &doccls, bool *inputfilecheck, const TCHAR *chkinputfile) {
	ablib::TextFile tf;
	bool main = false;
	if (inputfilecheck != nullptr)*inputfilecheck = false;
	auto dir = ablib::Pathname(file).dirname();
	if (!tf.Open(file, ablib::TextFile::read)) return false;
	bool isinverbatim = false;
	TCHAR buf[4096];
	while (tf.ReadLine(buf, 4095)) {
		// verbatim̓XLbv
		auto per = ::_tcsstr(buf, _T("%"));
		auto bver = ::_tcsstr(buf, _T("\\begin{verbatim}"));
		if (bver != nullptr && (per == nullptr || per > bver)) {
			isinverbatim = true;
			continue;
		}
		if (isinverbatim) {
			auto ever = ::_tcsstr(buf, _T("\\end{verbatim}"));
			if (ever != nullptr && (per == nullptr || per > ever)) {
				isinverbatim = false;
			}
			continue;
		}
		if (inputfilecheck != nullptr && !*inputfilecheck) {
			auto inputp = GetInput(buf, dir + _T("\\"), _T("\\input"));
			auto inclp = GetInput(buf, dir + _T("\\"), _T("\\include"));

			*inputfilecheck = (File::CheckSameFile(chkinputfile, inputp.c_str())) ||
				(File::CheckSameFile(chkinputfile, inclp.c_str()));
		}
		if (!main) {
			auto ver = ::_tcsstr(buf, _T("\\verb"));
			auto cls = ::_tcsstr(buf, _T("\\documentclass"));
			auto sty = ::_tcsstr(buf, _T("\\documentstyle"));
			auto musitop = buf + 99999;
			if (per != nullptr)musitop = std::min(musitop, per);
			if (ver != nullptr)musitop = std::min(musitop, ver);
			bool musi = (ver != nullptr || per != nullptr);
			// RgȂC\documentclas\documentstyle% or \verbɐsD
			main = ((cls != nullptr && (!musi || musitop > cls)) || (sty != nullptr && (!musi || musitop > sty)));
			if (main) {
#ifdef UNICODE
				std::wregex reg;
				std::wcmatch match;
#else
				std::regex reg;
				std::cmatch match;
#endif
				reg.assign(_T("\\\\document(class|style)\\[([^\\]]*)\\]"));
				if (std::regex_search(buf, match, reg))option = match.str(2);
				else option = _T("");

				reg.assign(_T("\\\\document(class|style)[^\\{]*\\{([^\\}]*)\\}"));
				if (std::regex_search(buf, match, reg))doccls = match.str(2);
				else doccls = _T("");
			}
		}
		if (main && (inputfilecheck == nullptr || *inputfilecheck))break;
	}
	return main;
}

const TCHAR *TeXProject::FindParentFile(const TCHAR *ff){
	ablib::string file = ff;
	//܂͎`FbND
	if (SearchDocumentClass(file, m_option, m_docclass, nullptr, nullptr))return ff;
	// ełȂȂ΁C̃t@CD
	return FindParent(file);
}

const TCHAR *TeXProject::FindParent(const ablib::string &f){
	static ablib::string rv;
	ablib::string dir = ablib::Pathname(f).dirname();
	while(dir != _T("")){
		ablib::system::FindFile ff;
		if(ff.Begin(dir + _T("\\*.tex"))){
			WIN32_FIND_DATA wfd;
			while(ff.Next(&wfd)){
				ablib::string file = dir + _T("\\") + wfd.cFileName;
				// Ώۃt@CƓꍇ̓XLbvDiKȏlXgĂꍇ̓_邪CCɂȂD
				if(File::CheckSameFile(file.c_str(),f.c_str()))continue;
				bool input = false;
				ablib::string option, cls;
				bool main = SearchDocumentClass(file, option, cls, &input, f.c_str());
				if(input && main){
					rv = dir + _T("\\") + wfd.cFileName;
					m_option = option; m_docclass = cls;
					return rv.c_str();
				}else if(input){
					return FindParent(dir + _T("\\") + wfd.cFileName);
				}
			}
		}
		dir = ablib::Pathname(dir).dirname();
	}
	return _T("");
}

ablib::string TeXProject::Exec_kpsewhich(const TCHAR *file,const TCHAR *dir,const TCHAR *progname){
	ablib::string f = file;
	int i = 0;
	while((i = f.find(_T(","),i)) != ablib::string::npos){
		f[i] = ' ';
		++i;
	}
	
	ablib::system::Process process;
	ablib::system::Process::ProcessStartInfo si;
	si.FileName = _T("");
	si.Arguments = _T("kpsewhich");
	if(progname && *progname){
		si.Arguments += _T(" --progname=");
		si.Arguments += progname;
	}
	si.Arguments += _T(" ") + f;
	si.RedirectStandardOutput = si.RedirectStandardError = true;
	si.RedirectStandardInput = true;
	si.WorkingDirectory = dir;
	si.CreateNoWindow = true;si.ShowState = ablib::system::Process::ProcessStartInfo::hide;

	process.StartInfo(si);
	
	if(!process.Start())return _T("");
	
	process.WaitForExit();

	TCHAR buf[4096];
	ablib::string rv;
	DWORD readsize;
	while(readsize = process.Read(buf,4095)){
		buf[readsize] = '\0';
		rv += buf;
	}
	DEBUGSTRING(_T("macrodll::TeXProject::Exec_kpsewhich : ߂lu%sv"),rv.c_str());
	return rv;
}

int TeXProject::kpsewhich(const TCHAR *file,const TCHAR *dir,const TCHAR *progname){
	ablib::string rv = Exec_kpsewhich(file,dir,progname);
	m_kpsewhich.clear();
	split(m_kpsewhich,rv,_T("\r\n"));
	return m_kpsewhich.size();
}

/*
int TeXProject::Collect(const TCHAR *nowfile,const TCHAR *reg,const TCHAR *getstr){
	int rv = 0,num;
	bool fail = false;
	for(UINT i = 0 ; i < m_files.size() ; ++i){
		if(!File::CheckSameFile(nowfile,m_files[i].name.c_str())){
			num = m_cs.Collect(m_files[i].name.c_str(),reg,getstr);
			if(num >= 0){rv += num;m_collectsizes.push_back(num);}
			else fail = true;
		}
	}
	if(fail)return -1;
	else return rv;
}

const TCHAR *TeXProject::CollectGetFileName(int i){
	if(i < 0 || i >= m_cs.GetDataSize())return _T("");
	int sum = 0;
	for(std::vector<int>::size_type k = 0 ; k < m_collectsizes.size() ; ++k){
		sum += m_collectsizes[k];
		if(i < sum)return m_files[k].name.c_str();
	}
	return _T("");
}

int TeXProject::Bib_CreateFileList(){
	ablib::string bibs;
	for(std::vector<FileData>::size_type i = 0 ; i < m_files.size() ; ++i){
		bibs += m_bibtex.CreateList(m_files[i].name);
		bibs += _T(" ");
	}
	ablib::string dir = ablib::Pathname(m_files[0].name).dirname();
	bool onlyspace = true;
	for (ablib::string::size_type i = 0; i < bibs.length(); ++i) {
		if (bibs[i] != ' ') { onlyspace = false; break; }
	}
	if(onlyspace)return 0;
	bibs = Exec_kpsewhich(bibs.c_str(),dir.c_str(),NULL);
	SlashToYen(bibs);
	split(m_bibtex.m_bibfiles,bibs,_T("\r\n"));
	for(std::vector<ablib::string>::size_type i = 0 ; i < m_bibtex.m_bibfiles.size() ; ++i){
		m_bibtex.m_bibfiles[i].replace(_T("/"),_T("\\"));
		if(
			m_bibtex.m_bibfiles[i].find(_T("\\")) == ablib::string::npos ||
			m_bibtex.m_bibfiles[i][0] == '.'
		)m_bibtex.m_bibfiles[i] = dir + _T("\\") + m_bibtex.m_bibfiles[i];
//		MessageBox(NULL,m_bibtex.m_bibfiles[i].c_str(),NULL,0);
	}
	return m_bibtex.m_bibfiles.size();
}
*/
